程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C++ >> C++入門知識 >> HDU 5025 Saving Tang Monk(bfs)

HDU 5025 Saving Tang Monk(bfs)

編輯:C++入門知識

HDU 5025 Saving Tang Monk(bfs)



Problem Description 《Journey to the West》(also 《Monkey》) is one of the Four Great Classical Novels of Chinese literature. It was written by Wu Cheng'en during the Ming Dynasty. In this novel, Monkey King Sun Wukong, pig Zhu Bajie and Sha Wujing, escorted Tang Monk to India to get sacred Buddhism texts.

During the journey, Tang Monk was often captured by demons. Most of demons wanted to eat Tang Monk to achieve immortality, but some female demons just wanted to marry him because he was handsome. So, fighting demons and saving Monk Tang is the major job for Sun Wukong to do.

Once, Tang Monk was captured by the demon White Bones. White Bones lived in a palace and she cuffed Tang Monk in a room. Sun Wukong managed to get into the palace. But to rescue Tang Monk, Sun Wukong might need to get some keys and kill some snakes in his way.

The palace can be described as a matrix of characters. Each character stands for a room. In the matrix, 'K' represents the original position of Sun Wukong, 'T' represents the location of Tang Monk and 'S' stands for a room with a snake in it. Please note that there are only one 'K' and one 'T', and at most five snakes in the palace. And, '.' means a clear room as well '#' means a deadly room which Sun Wukong couldn't get in.

There may be some keys of different kinds scattered in the rooms, but there is at most one key in one room. There are at most 9 kinds of keys. A room with a key in it is represented by a digit(from '1' to '9'). For example, '1' means a room with a first kind key, '2' means a room with a second kind key, '3' means a room with a third kind key... etc. To save Tang Monk, Sun Wukong must get ALL kinds of keys(in other words, at least one key for each kind).

For each step, Sun Wukong could move to the adjacent rooms(except deadly rooms) in 4 directions(north, west, south and east), and each step took him one minute. If he entered a room in which a living snake stayed, he must kill the snake. Killing a snake also took one minute. If Sun Wukong entered a room where there is a key of kind N, Sun would get that key if and only if he had already got keys of kind 1,kind 2 ... and kind N-1. In other words, Sun Wukong must get a key of kind N before he could get a key of kind N+1 (N>=1). If Sun Wukong got all keys he needed and entered the room in which Tang Monk was cuffed, the rescue mission is completed. If Sun Wukong didn't get enough keys, he still could pass through Tang Monk's room. Since Sun Wukong was a impatient monkey, he wanted to save Tang Monk as quickly as possible. Please figure out the minimum time Sun Wukong needed to rescue Tang Monk.
Input There are several test cases.

For each case, the first line includes two integers N and M(0 < N <= 100, 0<=M<=9), meaning that the palace is a N×N matrix and Sun Wukong needed M kinds of keys(kind 1, kind 2, ... kind M).

Then the N × N matrix follows.

The input ends with N = 0 and M = 0.
Output For each test case, print the minimum time (in minutes) Sun Wukong needed to save Tang Monk. If it's impossible for Sun Wukong to complete the mission, print "impossible"(no quotes).
Sample Input
3 1
K.S
##1
1#T
3 1
K#T
.S#
1#.
3 2
K#T
.S.
21.
0 0

Sample Output
5
impossible
8

Source 2014 ACM/ICPC Asia Regional Guangzhou Online
Recommend hujie | We have carefully selected several similar problems for you: 5031 5030 5029 5028 5027

思路:一直找鑰匙,如果發現鑰匙找齊並且碰到唐生,就是結果


#include
#include
#include
#include
#include
#include
#include

#define L(x) (x<<1)
#define R(x) (x<<1|1)
#define MID(x,y) ((x+y)>>1)
using namespace std;
#define N 105
#define INF 0x3f3f3f3f

int mark[N][N],vis[N][N][11];
int n,m;
int k;
int ans;
int sx,sy;

char a[N][N];

struct stud{
int x,y,s,k;
int time;
 friend bool operator <(stud a,stud b)
 {
	return a.time>b.time;
 }
};

int step[4][2]={1,0,-1,0,0,1,0,-1};

int judge(int x,int y)
{
	if(x>=0&&x=0&&yq;

void bfs()
{
	int i,j;

	struct stud cur,next;
	while(!q.empty())
		q.pop();

	cur.x=sx;
	cur.y=sy;
	cur.time=0;
	cur.s=0;
	cur.k=1;
	q.push(cur);

	while(!q.empty())
	{
	   cur=q.top();
	   q.pop();

       if(cur.k==m+1&&a[cur.x][cur.y]=='T')
	   {
	   	ans=cur.time;
	   	return ;
	   }

		for(i=0;i<4;i++)
		{
			int xx=cur.x+step[i][0];
			int yy=cur.y+step[i][1];
			if(!judge(xx,yy)||a[xx][yy]=='#') continue;

			next.x=xx;
			next.y=yy;
			next.s=cur.s;
			next.k=cur.k;
			next.time=cur.time+1;

			if(a[xx][yy]=='S')
			{
				int tt=1<






  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved